#include maps\_utility; 
#include common_scripts\utility;
#include maps\_zombiemode_utility;

dviiBuildablePrecache()
{
	/*
	Used in-case the level doesn't contain any perks
	*/
	PrecacheItem( "zombie_knuckle_crack" );
}

dviiBuildableConfig()
{
	/*--------------------
	 Hint strings used on the bench trigger
	----------------------*/
	level.Bench_Add_Item_Hint_String = "Press & Hold &&1 too add item"; 			//&&1 = players interact/use key bind :: This message is shown on players screen when they have an item to add
	
	level.Bench_Take_Item_Hint_String = "Press & Hold &&1 too take item"; 			//&&1 = players interact/use key bind :: This message is shown on players screen when they have finished crafting the item and can take it
	
	
	/*--------------------
	 Pickup model and brushmodel config
	----------------------*/
	level.Delete_Model_After_Pickup = true;					//change to false if you don't want the model deleted after pickup
	
	level.Hide_Model_After_Pickup = false;					//change to true to hide the model after pickup (Only applies if Delete_Model_After_Pickup = false; (Used in-case you want to reuse the model after)
	
	/*--------------------
	 Flags that are set either when item is built or when a player takes the built item
	----------------------*/
	
	level.Send_Flag_On_Build = false;						//change to true to set the flag when the item is built
	
	level.Send_Flag_On_Take = true;							//change to false if you don't want the flag to set when the player takes the finished built item
	
	level.Flag_Message_To_Send_On_Build = "item_built";		//Once a player has finished crafting an item, this message will be sent (Refer to example script to see how it is received)
	
	level.Flag_Message_To_Send_On_Take = "item_taken";		//Once a player has taken the crafted item, this message will be sent (Refer to example script to see how it is received)
	
	/*--------------------
	 Bench models and brushmodels config
	----------------------*/
	
	level.Delete_Bench_Item_After_Pickup = true;			//change to false if you don't want the crafted item to be deleted
	
	/*--------------------
	 Other bench configs
	----------------------*/
	
	level.Wait_Time_On_Item_Add = 3;						//seconds to wait till the bench can be used again to add another item (0 = Instant)
	
	level.Show_Knuckles_On_Item_Add = true;					//change to false if you don't want knuckle cracking to show when player adds an item to the bench
	
	level.Allow_Take_On_Build_Finish = true;				//change to false if you don't want the player to be able to take the item when finished
	
	/*--------------------
	Any scripts to work with dvii_buildables can be added here
	----------------------*/
	thread maps\dvii_item_built_example::dvii_Initialize(); //Refer to the dvii_item_built_example.gsc script too add function to your built item
}

dviiBuildableInit()
{
	level.dvii_bench = GetEntArray("dvii_bench","targetname");
	level.dvii_pickedup = [];
	level.dvii_items = 0;
	
	dviiBuildableConfig();
	dviiHideBenchModels();
	
	if(isDefined(level.Flag_Message_To_Send_On_Build) && level.Flag_Message_To_Send_On_Build != "" && level.Send_Flag_On_Build == true)
	{
		flag_init(level.Flag_Message_To_Send_On_Build);
	}
	if(isDefined(level.Flag_Message_To_Send_On_Take) && level.Flag_Message_To_Send_On_Take != "" && level.Send_Flag_On_Take == true)
	{
		flag_init(level.Flag_Message_To_Send_On_Take);
	}
	
	array_thread(level.dvii_bench,::dviiAssignTriggers);
}

dviiAssignTriggers()
{
	if(isDefined(self.script_noteworthy))
	{
		if(self.script_noteworthy == "bench")
		{
			self thread dviiBenchSetup();
		}
		else if(self.script_noteworthy == "pickup")
		{
			//level.dvii_pickups[level.dvii_pickups.size+1] = level.dvii_bench[i].itemname + " = " + level.dvii_bench[i].bench_link;
			if(self.classname == "trigger_use")
			{
				level.dvii_items++;
			}
			self thread dviiPickUpSetup();
		}
	}
	else
	{
		iPrintLn("Error; Found an object with no script_noteworthy defined");
	}
}

dviiBenchSetup()
{
	if(self.classname == "trigger_use")
	{
		self setCursorHint("HINT_NOICON");
		self sethintstring("");
		for(;;)
		{
			level waittill ("item_found");
			for(i = 0; i<level.dvii_pickedup.size; i++)
			{
				if(level.dvii_pickedup[i] != 0)
				{
					self sethintstring(level.Bench_Add_Item_Hint_String);
					self waittill( "trigger", player );
					if( is_player_valid( player ) )
					{
						self disable_trigger();
						if(level.Show_Knuckles_On_Item_Add == true)
						{
							player thread do_knuckle_crack();
						}
						wait(level.Wait_Time_On_Item_Add);
						dviiShowBenchModel(level.dvii_pickedup[i], "bench", true);
						self enable_trigger();
						level.dvii_items--;
					}
				}
			}
			level.dvii_pickedup = [];
			self sethintstring("");
			if(level.dvii_items == 0)
			{
				if(isDefined(level.Flag_Message_To_Send_On_Build) && level.Flag_Message_To_Send_On_Build != "" && level.Send_Flag_On_Build == true)
				{
					flag_set(level.Flag_Message_To_Send_On_Build);
				}
				if(level.Allow_Take_On_Build_Finish == false)
				{
					self delete();
				}
				else if(level.Allow_Take_On_Build_Finish == true)
				{
					self sethintstring(level.Bench_Take_Item_Hint_String);
					self waittill( "trigger", player );
					if( is_player_valid( player ) )
					{
						if(isDefined(level.Flag_Message_To_Send_On_Take) && level.Flag_Message_To_Send_On_Take != "" && level.Send_Flag_On_Take == true)
						{
							iPrintLn("Sending take flag");
							flag_set(level.Flag_Message_To_Send_On_Take);
						}
						if(level.Delete_Bench_Item_After_Pickup == true)
						{
							dviiPickUpModelDeleteHide(-666, "bench", false);
						}
						self delete();
						break;
					}
				}
			}
		}
	}
}

dviiPickUpSetup()
{
	if(self.classname == "trigger_use")
	{
		self setCursorHint("HINT_NOICON");
		for(;;)
		{
			self waittill( "trigger", player );
			if( is_player_valid( player ) )
			{
				level.dvii_pickedup[level.dvii_pickedup.size] = self.count;
				self sethintstring("");
				if(level.Delete_Model_After_Pickup == true || level.Hide_Model_After_Pickup == true)
				{
					dviiPickUpModelDeleteHide(self.count,"pickup", 0);
				}
				level notify ("item_found");
				self delete();
				break;
			}
		}
	}
}

dviiPickUpModelDeleteHide(entCount, noteworthy, show)
{
	for(i = 0; i<level.dvii_bench.size; i++)
	{
		tempCount = level.dvii_bench[i].count;
		if(tempCount == entCount || entCount == -666)
		{
			tempNoteworthy = level.dvii_bench[i].script_noteworthy;
			tempClassname = level.dvii_bench[i].classname;
			if(tempNoteworthy == noteworthy && tempClassname == "script_model" || tempNoteworthy == noteworthy && tempClassname == "script_brushmodel")
			{
				if(noteworthy == "pickup")
				{
					if(level.Delete_Model_After_Pickup == true)
					{
						level.dvii_bench[i] delete();
					}
					else if(level.Hide_Model_After_Pickup == true)
					{
						level.dvii_bench[i] hide();
					}
				}
				else if(noteworthy == "bench")
				{
					if(level.Delete_Bench_Item_After_Pickup == true && show == false)
					{
						level.dvii_bench[i] delete();
					}
					else
					{
						level.dvii_bench[i] show();
					}
				}
			}
		}	
	}
	level.dvii_bench = [];
	level.dvii_bench = GetEntArray("dvii_bench","targetname");
}

dviiHideBenchModels()
{
	for(i = 0; i<level.dvii_bench.size; i++)
	{
		tempNoteworthy = level.dvii_bench[i].script_noteworthy;
		tempClassname = level.dvii_bench[i].classname;
		if(tempNoteworthy == "bench" && tempClassname == "script_brushmodel" || tempNoteworthy == "bench" && tempClassname == "script_model")
		{
			level.dvii_bench[i] hide();
		}
	}
}

dviiShowBenchModel(entCount)
{
	for(i = 0; i<level.dvii_bench.size; i++)
	{
		tempCount = level.dvii_bench[i].count;
		if(tempCount == entCount)
		{
			tempNoteworthy = level.dvii_bench[i].script_noteworthy;
			tempClassname = level.dvii_bench[i].classname;
			if(tempNoteworthy == "bench" && tempClassname == "script_model" || tempNoteworthy == "bench" && tempClassname == "script_brushmodel")
			{
				level.dvii_bench[i] show();
			}
		}	
	}
}
//-----------
//Knuckle cracking when player adds an item to the bench
//-----------
do_knuckle_crack()
{
	self DisableOffhandWeapons();
	self DisableWeaponCycling();

	self AllowLean( false );
	self AllowAds( false );
	self AllowSprint( false );
	self AllowProne( false );      
	self AllowMelee( false );

	if ( self GetStance() == "prone" )
	{
	  self SetStance( "crouch" );
	}

	primaries = self GetWeaponsListPrimaries();

	gun = self GetCurrentWeapon();
	weapon = "zombie_knuckle_crack";   
	self GiveWeapon( weapon );
	self SwitchToWeapon( weapon );
	self waittill_any( "fake_death", "death", "player_downed", "weapon_change_complete" );
	self EnableOffhandWeapons();
	self EnableWeaponCycling();

	self AllowLean( true );
	self AllowAds( true );
	self AllowSprint( true );
	self AllowProne( true );      
	self AllowMelee( true );
	self GiveWeapon( gun );
	self SwitchToWeapon( gun );
}